<template>
  <q-page class="q-pl-md bg-grey-1 splitscreen" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <div v-if="dimension">
          <DimensionCard :dimension="dimension" v-on:dim_conceptClicked="concept_clicked"></DimensionCard>
        </div>
      </template>

      <template v-slot:separator>
      </template>
      <template v-slot:after>
        <div v-if="node">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>

    </q-splitter>

  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import DimensionCard from "components/DimensionCard";
import CellValue from "components/CellValue";
import SharedMethods from "components/SharedMethods";

export default {
  name: "DimensionDetail",
  components: {CellValue, DimensionCard},
  props: {
    rowid: String,
    dts_name: String,
    nt_version: String
  },
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },

  mounted() {
    if (this.rowid) {
      this.fetchData()
    }
  },
  data() {
    return {
      dimension: undefined,
      node: undefined,
      panelWidth: 50,
    }
  },
  watch: {
    rowid: function() {
      this.fetchData()
    }
  },
  methods: {
    fetchData: function () {
      api
        .get( "/dts/" + this.dts_name + "/dimensions/" + this.rowid, {params: {nt_version: this.nt_version}})
        .then(response => {this.dimension = response.data[0]; this.node = this.dimension})
    },
    close_detail: function () {
      this.panelWidth = 100
    },
    concept_clicked: function(concept) {
      this.node = {concept: concept}
      if (this.panelWidth === 100) {
        this.panelWidth = 50
      }
    }
  }

}
</script>

<style scoped lang="scss">

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}
.row {
  padding: 5px 0 0 0;
}
.label {
  padding: 5px 0 5px 10px;
}
table {
  border-spacing: 5px;
  width: 100%;
}
th {
  text-align: left;
}
td.tiny {
  width: 10%;
}
</style>
